import { inject, provide } from "vue";
import { keyInProvides } from "@varlet/use";
const HIGHLIGHTER_PROVIDER_KEY = Symbol("HIGHLIGHTER_PROVIDER_KEY");
function provideHighlighterProvider(highlighterProvider) {
  provide(HIGHLIGHTER_PROVIDER_KEY, highlighterProvider);
}
function injectHighlighterProvider() {
  if (!keyInProvides(HIGHLIGHTER_PROVIDER_KEY)) {
    return { highlighter: null, theme: null };
  }
  return inject(HIGHLIGHTER_PROVIDER_KEY);
}
export {
  HIGHLIGHTER_PROVIDER_KEY,
  injectHighlighterProvider,
  provideHighlighterProvider
};
